
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega88A
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega88A
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1279
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x04FF
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _encoder_state=R4
	.DEF _j=R3
	.DEF _volume=R6
	.DEF _vol2=R5
	.DEF _voltime=R7
	.DEF _del=R9
	.DEF _cyfh=R12
	.DEF _cyfm=R11
	.DEF _cyfl=R14
	.DEF _girno=R13

;GPIOR0 INITIALIZATION VALUE
	.EQU __GPIOR0_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP _ext_int1_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _adc_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_merka:
	.DB  0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7
	.DB  0x8,0x9,0xA,0xB,0xC,0xD,0xE,0xF
	.DB  0x10,0x12,0x14,0x18,0x1D,0x21,0x27,0x2E
	.DB  0x36,0x3F,0x4A,0x57,0x66,0x78
_bukvy:
	.DB  0x79,0x63,0xB8,0xBB,0xB8,0xBF,0x65,0xBB
	.DB  0xC4,0x6,0x0,0x6,0x1,0x7,0x2D,0x2
_x:
	.DB  0x6,0xA,0x8,0x7,0x5,0xB,0x8,0x4
	.DB  0xA,0x5,0x9,0x6,0x9,0xC,0x7,0xB
_y:
	.DB  0x1,0x0,0x0,0x1,0x0,0x0,0x1,0x0
	.DB  0x1,0x1,0x0,0x0,0x1,0x0,0x0,0x1
_znakog:
	.DB  0x1E,0x9,0x9,0x9,0x9,0x9,0x7,0x0
	.DB  0x12,0xF,0x8,0xC,0xA,0x8,0x17,0x0
	.DB  0x18,0x8,0x8,0x8,0x8,0x8,0x14,0x0
	.DB  0x0,0x0,0x0,0x1B,0x0,0x0,0x0,0x0
	.DB  0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x0
	.DB  0x18,0x18,0x18,0x1B,0x18,0x18,0x18,0x0
	.DB  0x1E,0x9,0x8,0xE,0x9,0x9,0x17,0x0
	.DB  0x1E,0x9,0x9,0xD,0xB,0x8,0x14,0x0

_0x2000003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x200

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.0 Professional
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : bobyor1
;Version :
;Date    : 03.12.2015
;Author  :
;Company :
;Comments:
;
;
;Chip type               : ATmega88A
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega88a.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif
;
;#include <delay.h>
;
;// Alphanumeric LCD Module functions
;#include <alcd.h>
;
;eeprom char volstore;
;eeprom unsigned int correctl, correctr;
;char encoder_state,zamer[2],falltime[2];
;volatile signed char encoder_pos;
;signed char j,volume,vol2;
;//char lin[2];
;int voltime,del,volcor[2];
;char cyfh,cyfm,cyfl,girno,polu,nichego,dela;
;flash char merka[30]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,18,20,24,29,33,39,46,54,63,74,87,102,120};
;flash char bukvy[16]={0x79,0x63,0xb8,0xbb,0xb8,0xbf,0x65,0xbb,0xc4,6,0,6,1,7,0x2d,2};
;flash char x[16]={6,10,8,7,5,11,8,4,10,5,9,6,9,12,7,11};
;flash char y[16]={1, 0,0,1,0, 0,1,0, 1,1,0,0,1, 0,0, 1};
; int  corr[2];
;bit krut,channel,on=0;
;flash char znakog[64]={
;// O
;0b00011110,
;0b00001001,
;0b00001001,
;0b00001001,
;0b00001001,
;0b00001001,
;0b00000111,
;0b00000000,
;// 
;0b00010010,
;0b00001111,
;0b00001000,
;0b00001100,
;0b00001010,
;0b00001000,
;0b00010111,
;0b00000000,
;// 1
;0b00011000,
;0b00001000,
;0b00001000,
;0b00001000,
;0b00001000,
;0b00001000,
;0b00010100,
;0b00000000,
;// -
;0b00000000,
;0b00000000,
;0b00000000,
;0b00011011,
;0b00000000,
;0b00000000,
;0b00000000,
;0b00000000,
;//  
;0b00011011,
;0b00011011,
;0b00011011,
;0b00011011,
;0b00011011,
;0b00011011,
;0b00011011,
;0b00000000,
;//  
;0b00011000,
;0b00011000,
;0b00011000,
;0b00011011,
;0b00011000,
;0b00011000,
;0b00011000,
;0b00000000,
;// 
;0b00011110,
;0b00001001,
;0b00001000,
;0b00001110,
;0b00001001,
;0b00001001,
;0b00010111,
;0b00000000,
;// 
;0b00011110,
;0b00001001,
;0b00001001,
;0b00001101,
;0b00001011,
;0b00001000,
;0b00010100,
;0b00000000};
;
;//   .  2 , 
;// ,   ,
;//   
;#define TR(x, y) (((x) << 2) | (y) )
;
;
;// External Interrupt 1 service routine
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 007F {

	.CSEG
_ext_int1_isr:
; 0000 0080 // Place your code here
; 0000 0081  return;//PORTC&=251;
	RETI
; 0000 0082  }
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0085 {
_timer0_ovf_isr:
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0086 // Place your code here
; 0000 0087     char pins = (PINB & 0xC0) >> 2;
; 0000 0088 	//   0-      ,   
; 0000 0089 	    if ((encoder_state & 16) == (pins & 16))
	ST   -Y,R17
;	pins -> R17
	IN   R30,0x3
	ANDI R30,LOW(0xC0)
	RCALL SUBOPT_0x0
	RCALL __ASRW2
	MOV  R17,R30
	MOV  R30,R4
	ANDI R30,LOW(0x10)
	MOV  R26,R30
	MOV  R30,R17
	ANDI R30,LOW(0x10)
	CP   R30,R26
	BREQ _0x80
; 0000 008A 		return;
; 0000 008B 	//     ,    
; 0000 008C 	// 2  
; 0000 008D 	encoder_state = ((encoder_state << 2) | pins) & 0xF0;
	MOV  R30,R4
	LSL  R30
	LSL  R30
	OR   R30,R17
	ANDI R30,LOW(0xF0)
	MOV  R4,R30
; 0000 008E     //  ,    ,  
; 0000 008F 	if (encoder_state == TR(0,48)&&encoder_pos>-20) encoder_pos--;
	LDI  R30,LOW(48)
	CP   R30,R4
	BRNE _0x5
	RCALL SUBOPT_0x1
	LDI  R30,LOW(236)
	CP   R30,R26
	BRLT _0x6
_0x5:
	RJMP _0x4
_0x6:
	LDS  R30,_encoder_pos
	SUBI R30,LOW(1)
	RCALL SUBOPT_0x2
; 0000 0090     if (encoder_state == TR(32,16)&&encoder_pos<0) encoder_pos=0;
_0x4:
	LDI  R30,LOW(144)
	CP   R30,R4
	BRNE _0x8
	RCALL SUBOPT_0x1
	CPI  R26,0
	BRLT _0x9
_0x8:
	RJMP _0x7
_0x9:
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x2
; 0000 0091 	if (encoder_state == TR(32,16)&&encoder_pos<31) encoder_pos++;
_0x7:
	LDI  R30,LOW(144)
	CP   R30,R4
	BRNE _0xB
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x1F)
	BRLT _0xC
_0xB:
	RJMP _0xA
_0xC:
	LDS  R30,_encoder_pos
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x2
; 0000 0092     voltime=1000;
_0xA:
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
; 0000 0093 }
_0x80:
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	RETI
;
;#define FIRST_ADC_INPUT 0
;#define LAST_ADC_INPUT 1
;volatile  int adc_data[LAST_ADC_INPUT-FIRST_ADC_INPUT+1];
;#define ADC_VREF_TYPE 0x40
;
;// ADC interrupt service routine
;// with auto input scanning
;interrupt [ADC_INT] void adc_isr(void)
; 0000 009D {
_adc_isr:
	ST   -Y,R24
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 009E static unsigned char input_index=0;
; 0000 009F // Read the AD conversion result
; 0000 00A0 adc_data[input_index]=ADCW;
	LDS  R30,_input_index_S0000002000
	LDI  R26,LOW(_adc_data)
	LDI  R27,HIGH(_adc_data)
	RCALL SUBOPT_0x5
	ADD  R26,R30
	ADC  R27,R31
	LDS  R30,120
	LDS  R31,120+1
	ST   X+,R30
	ST   X,R31
; 0000 00A1 //vol[input_index]= adc_data[input_index];
; 0000 00A2 // Select next ADC input
; 0000 00A3 if (++input_index > (LAST_ADC_INPUT-FIRST_ADC_INPUT))
	LDS  R26,_input_index_S0000002000
	SUBI R26,-LOW(1)
	STS  _input_index_S0000002000,R26
	CPI  R26,LOW(0x2)
	BRLO _0xD
; 0000 00A4    input_index=0;
	LDI  R30,LOW(0)
	STS  _input_index_S0000002000,R30
; 0000 00A5 ADMUX=(FIRST_ADC_INPUT | (ADC_VREF_TYPE & 0xff))+input_index;
_0xD:
	LDS  R30,_input_index_S0000002000
	SUBI R30,-LOW(64)
	STS  124,R30
; 0000 00A6 // Delay needed for the stabilization of the ADC input voltage
; 0000 00A7 delay_us(1);
	__DELAY_USB 3
; 0000 00A8 // Start the AD conversion
; 0000 00A9 ADCSRA|=0x40;
	LDS  R30,122
	ORI  R30,0x40
	RCALL SUBOPT_0x6
; 0000 00AA }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R24,Y+
	RETI
;
;// Declare your global variables here
;void ssav(void)
; 0000 00AE {if (!PIND.3)return;
_ssav:
	SBIS 0x9,3
	RET
; 0000 00AF ADCSRA=0xCD;                              //ADCSRA=0xCB;
	RCALL SUBOPT_0x7
; 0000 00B0 TIMSK0=0x00;
; 0000 00B1 while(1)
_0xF:
; 0000 00B2     {
; 0000 00B3     lcd_init(16);
	RCALL SUBOPT_0x8
; 0000 00B4     for (j=0;j<80;j++)
	CLR  R3
_0x13:
	LDI  R30,LOW(80)
	CP   R3,R30
	BRGE _0x14
; 0000 00B5         {
; 0000 00B6         if(j==0) lcd_gotoxy(4,0);
	TST  R3
	BRNE _0x15
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	RCALL _lcd_gotoxy
; 0000 00B7         if(j<16)lcd_putchar(bukvy[j]);
_0x15:
	LDI  R30,LOW(16)
	CP   R3,R30
	BRGE _0x16
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xC
; 0000 00B8 
; 0000 00B9         if(j==8) lcd_gotoxy(5,1);
_0x16:
	LDI  R30,LOW(8)
	CP   R30,R3
	BRNE _0x17
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
; 0000 00BA         if(j>63){
_0x17:
	LDI  R30,LOW(63)
	CP   R30,R3
	BRGE _0x18
; 0000 00BB             lcd_gotoxy(x[j-64],y[j-64]);
	MOV  R30,R3
	LDI  R31,0
	SBRC R30,7
	SER  R31
	SUBI R30,LOW(64)
	SBCI R31,HIGH(64)
	MOVW R26,R30
	SUBI R30,LOW(-_x*2)
	SBCI R31,HIGH(-_x*2)
	LPM  R30,Z
	ST   -Y,R30
	MOVW R30,R26
	SUBI R30,LOW(-_y*2)
	SBCI R31,HIGH(-_y*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _lcd_gotoxy
; 0000 00BC             lcd_putchar (32);
	RCALL SUBOPT_0xF
; 0000 00BD             }
; 0000 00BE         for(del=0; del<10000;del++)
_0x18:
	CLR  R9
	CLR  R10
_0x1A:
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	CP   R9,R30
	CPC  R10,R31
	BRGE _0x1B
; 0000 00BF             {if (PINB.6!=krut)
	RCALL SUBOPT_0x10
	BRNE _0x2020003
; 0000 00C0                 {voltime=1000;
; 0000 00C1                 return;
; 0000 00C2                 }
; 0000 00C3             if(!PIND.3)return;
	SBIS 0x9,3
	RET
; 0000 00C4 
; 0000 00C5      //       if((adc_data[0]>corr[0])||(adc_data[1]>corr[1]))return;
; 0000 00C6               if(((adc_data[0]-corr[0])>3)||((adc_data[1]-corr[1])>3))return;
	RCALL SUBOPT_0x11
	SBIW R30,4
	BRGE _0x1F
	RCALL SUBOPT_0x12
	SBIW R26,4
	BRLT _0x1E
_0x1F:
	RET
; 0000 00C7             }
_0x1E:
	RCALL SUBOPT_0x13
	__ADDWRR 9,10,30,31
	RJMP _0x1A
_0x1B:
; 0000 00C8         }
	INC  R3
	RJMP _0x13
_0x14:
; 0000 00C9      }
	RJMP _0xF
; 0000 00CA  }
;
;void adclog(void)
; 0000 00CD {       ADCSRA=0xCD;         //ADCSRA=0xCB;
_adclog:
	RCALL SUBOPT_0x7
; 0000 00CE         TIMSK0=0x00;
; 0000 00CF         del=1000;
	RCALL SUBOPT_0x3
	__PUTW1R 9,10
; 0000 00D0         while(1){
_0x21:
; 0000 00D1         if (!PIND.3)return;
	SBIS 0x9,3
	RET
; 0000 00D2 
; 0000 00D3 volcor[0]=adc_data[0]-corr[0];
	RCALL SUBOPT_0x11
	STS  _volcor,R30
	STS  _volcor+1,R31
; 0000 00D4 volcor[1]=adc_data[1]-corr[1];
	RCALL SUBOPT_0x14
	__GETW2MN _corr,2
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1MN _volcor,2
; 0000 00D5 linear:
_0x25:
; 0000 00D6 if   (PINB.6!=krut)
	RCALL SUBOPT_0x10
	BREQ _0x26
; 0000 00D7       {voltime=1000;
_0x2020003:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x4
; 0000 00D8       return;}
	RET
; 0000 00D9 
; 0000 00DA if (volcor[channel]<=3)del--;
_0x26:
	RCALL SUBOPT_0x15
	LDI  R26,LOW(_volcor)
	LDI  R27,HIGH(_volcor)
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x16
	SBIW R30,4
	BRGE _0x27
	__GETW1R 9,10
	SBIW R30,1
	RJMP _0x7F
; 0000 00DB else del=1000;
_0x27:
	RCALL SUBOPT_0x3
_0x7F:
	__PUTW1R 9,10
; 0000 00DC 
; 0000 00DD 
; 0000 00DE     j=0;
	CLR  R3
; 0000 00DF         lcd_gotoxy(0,channel);
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x15
	ST   -Y,R30
	RCALL _lcd_gotoxy
; 0000 00E0         if(!channel) lcd_putchar(0xA7);
	SBIC 0x1E,1
	RJMP _0x29
	LDI  R30,LOW(167)
	RCALL SUBOPT_0x17
; 0000 00E1         if(channel) lcd_putchar(0xA8);
_0x29:
	SBIS 0x1E,1
	RJMP _0x2A
	LDI  R30,LOW(168)
	RCALL SUBOPT_0x17
; 0000 00E2 //        if (j<30) {
; 0000 00E3             while ((volcor[channel]>merka[j])&&(j<30)) j++;//}
_0x2A:
_0x2B:
	RCALL SUBOPT_0x15
	LDI  R26,LOW(_volcor)
	LDI  R27,HIGH(_volcor)
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x16
	MOVW R26,R30
	RCALL SUBOPT_0xB
	SUBI R30,LOW(-_merka*2)
	SBCI R31,HIGH(-_merka*2)
	LPM  R30,Z
	RCALL SUBOPT_0x0
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x2E
	LDI  R30,LOW(30)
	CP   R3,R30
	BRLT _0x2F
_0x2E:
	RJMP _0x2D
_0x2F:
	INC  R3
	RJMP _0x2B
_0x2D:
; 0000 00E4 if (j>=zamer[channel])
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x18
	LD   R30,Z
	RCALL SUBOPT_0x19
	BRLT _0x30
; 0000 00E5             {zamer[channel]=j;
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x18
	ST   Z,R3
; 0000 00E6             falltime[channel]=255;}
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x1A
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 00E7          else falltime[channel]--;
	RJMP _0x31
_0x30:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x1B
; 0000 00E8 
; 0000 00E9          if (falltime[channel]<245){
_0x31:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x1A
	LD   R26,Z
	CPI  R26,LOW(0xF5)
	BRSH _0x32
; 0000 00EA             if(zamer[channel]>0) zamer[channel]--;
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x18
	LD   R26,Z
	CPI  R26,LOW(0x1)
	BRLO _0x33
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x1B
; 0000 00EB             falltime[channel]=255;}
_0x33:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x1A
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 00EC    //      if (zamer[channel]>30) zamer[channel]=30;
; 0000 00ED          polu=(zamer[channel]&1);
_0x32:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x18
	LD   R30,Z
	ANDI R30,LOW(0x1)
	RCALL SUBOPT_0x1C
; 0000 00EE          girno=(zamer[channel]>>1);
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x18
	LD   R30,Z
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1D
; 0000 00EF         nichego=15-girno-polu;
	LDI  R26,LOW(15)
	LDI  R27,HIGH(15)
	RCALL SUBOPT_0x1E
; 0000 00F0         if (nichego>200) nichego=0;
	LDS  R26,_nichego
	CPI  R26,LOW(0xC9)
	BRLO _0x34
	LDI  R30,LOW(0)
	STS  _nichego,R30
; 0000 00F1 
; 0000 00F2         for(j=0;j<girno;j++)lcd_putchar (4);
_0x34:
	CLR  R3
_0x36:
	MOV  R30,R13
	RCALL SUBOPT_0x19
	BRGE _0x37
	RCALL SUBOPT_0x9
	RCALL _lcd_putchar
	INC  R3
	RJMP _0x36
_0x37:
; 0000 00F3 if(polu==1)lcd_putchar(5);
	LDS  R26,_polu
	CPI  R26,LOW(0x1)
	BRNE _0x38
	RCALL SUBOPT_0xD
	RCALL _lcd_putchar
; 0000 00F4         for(j=0;j<nichego;j++)lcd_putchar (3);
_0x38:
	CLR  R3
_0x3A:
	LDS  R30,_nichego
	RCALL SUBOPT_0x19
	BRGE _0x3B
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x17
	INC  R3
	RJMP _0x3A
_0x3B:
; 0000 00F6 channel^=1;
	LDI  R26,0
	SBIC 0x1E,1
	LDI  R26,1
	LDI  R30,LOW(1)
	EOR  R30,R26
	BRNE _0x3C
	CBI  0x1E,1
	RJMP _0x3D
_0x3C:
	SBI  0x1E,1
_0x3D:
; 0000 00F7     if(channel==1)goto linear ;
	SBIC 0x1E,1
	RJMP _0x25
; 0000 00F8     if (del<1)return;
	RCALL SUBOPT_0x13
	CP   R9,R30
	CPC  R10,R31
	BRGE _0x3F
	RET
; 0000 00F9      }
_0x3F:
	RJMP _0x21
; 0000 00FA     }
;void volu (void)
; 0000 00FC {
_volu:
; 0000 00FD         ADCSRA=0xC5;                     //  ADCSRA=0xC3;
	LDI  R30,LOW(197)
	RCALL SUBOPT_0x6
; 0000 00FE         TIMSK0=0x01;
	LDI  R30,LOW(1)
	STS  110,R30
; 0000 00FF         lcd_init(16);
	RCALL SUBOPT_0x8
; 0000 0100 while(1){if(!PIND.3)return;
_0x40:
	SBIS 0x9,3
	RET
; 0000 0101 
; 0000 0102         if(encoder_pos>0)volume=encoder_pos; else volume=0;
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x1)
	BRLT _0x44
	LDS  R6,_encoder_pos
	RJMP _0x45
_0x44:
	CLR  R6
; 0000 0103         if(encoder_pos==(-20))
_0x45:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0xEC)
	BREQ PC+2
	RJMP _0x46
; 0000 0104             {
; 0000 0105             #asm("cli")
	cli
; 0000 0106             lcd_init(16);
	RCALL SUBOPT_0x8
; 0000 0107 
; 0000 0108             correctl=(adc_data[0]+1);
	LDS  R30,_adc_data
	LDS  R31,_adc_data+1
	ADIW R30,1
	LDI  R26,LOW(_correctl)
	LDI  R27,HIGH(_correctl)
	RCALL SUBOPT_0x1F
; 0000 0109             delay_ms(200);
; 0000 010A 
; 0000 010B             correctr=(adc_data[1]+1);
	RCALL SUBOPT_0x14
	ADIW R30,1
	LDI  R26,LOW(_correctr)
	LDI  R27,HIGH(_correctr)
	RCALL SUBOPT_0x1F
; 0000 010C             delay_ms(200);
; 0000 010D             corr[0]=correctl;
	RCALL SUBOPT_0x20
; 0000 010E             corr[1]=correctr;
; 0000 010F             for(polu=0;polu<2;polu++)
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1C
_0x48:
	LDS  R26,_polu
	CPI  R26,LOW(0x2)
	BRSH _0x49
; 0000 0110                 {
; 0000 0111                 cyfh=(corr[polu]/100)|48;
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x16
	MOVW R26,R30
	RCALL SUBOPT_0x22
	RCALL __DIVW21
	ORI  R30,LOW(0x30)
	MOV  R12,R30
; 0000 0112                 cyfm=(corr[polu]%100);
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x16
	MOVW R26,R30
	RCALL SUBOPT_0x22
	RCALL __MODW21
	MOV  R11,R30
; 0000 0113                 cyfl=(cyfm%10)|48;
	MOV  R26,R11
	CLR  R27
	RCALL SUBOPT_0x23
	RCALL __MODW21
	ORI  R30,LOW(0x30)
	MOV  R14,R30
; 0000 0114                 cyfm=(cyfm/10)|48;
	MOV  R26,R11
	LDI  R27,0
	RCALL SUBOPT_0x23
	RCALL __DIVW21
	ORI  R30,LOW(0x30)
	MOV  R11,R30
; 0000 0115                 lcd_putchar (cyfh);
	ST   -Y,R12
	RCALL _lcd_putchar
; 0000 0116                 lcd_putchar (cyfm);
	ST   -Y,R11
	RCALL _lcd_putchar
; 0000 0117                 lcd_putchar (cyfl);
	ST   -Y,R14
	RCALL _lcd_putchar
; 0000 0118                 lcd_putchar (32);
	RCALL SUBOPT_0xF
; 0000 0119                 }
	LDS  R30,_polu
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x1C
	RJMP _0x48
_0x49:
; 0000 011A 
; 0000 011B             #asm("sei")
	sei
; 0000 011C             delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RCALL SUBOPT_0x24
; 0000 011D             }
; 0000 011E         if (vol2!=volume)
_0x46:
	CP   R6,R5
	BREQ _0x4A
; 0000 011F             {PORTB&=(0xE0|volume);
	RCALL SUBOPT_0x25
; 0000 0120             delay_ms(2);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0x24
; 0000 0121             PORTB|=volume;
	RCALL SUBOPT_0x26
; 0000 0122             vol2=volume;}
; 0000 0123         voltime--;
_0x4A:
	__GETW1R 7,8
	SBIW R30,1
	RCALL SUBOPT_0x4
; 0000 0124         lcd_gotoxy(0,0);
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xA
	RCALL _lcd_gotoxy
; 0000 0125         lcd_putchar (161);
	LDI  R30,LOW(161)
	RCALL SUBOPT_0x17
; 0000 0126         lcd_putchar (112);
	LDI  R30,LOW(112)
	RCALL SUBOPT_0x17
; 0000 0127         lcd_putchar (111);
	LDI  R30,LOW(111)
	RCALL SUBOPT_0x17
; 0000 0128         lcd_putchar (188);
	LDI  R30,LOW(188)
	RCALL SUBOPT_0x17
; 0000 0129         lcd_putchar (186);
	LDI  R30,LOW(186)
	RCALL SUBOPT_0x17
; 0000 012A         lcd_putchar (111);
	LDI  R30,LOW(111)
	RCALL SUBOPT_0x17
; 0000 012B         lcd_putchar (99);
	LDI  R30,LOW(99)
	RCALL SUBOPT_0x17
; 0000 012C         lcd_putchar (191);
	LDI  R30,LOW(191)
	RCALL SUBOPT_0x17
; 0000 012D         lcd_putchar (196);
	LDI  R30,LOW(196)
	RCALL SUBOPT_0x17
; 0000 012E         lcd_putchar (32);
	RCALL SUBOPT_0xF
; 0000 012F         cyfh=(volume/10)|48;
	RCALL SUBOPT_0x27
	RCALL __DIVW21
	ORI  R30,LOW(0x30)
	MOV  R12,R30
; 0000 0130         cyfl=(volume%10)|48;
	RCALL SUBOPT_0x27
	RCALL __MODW21
	ORI  R30,LOW(0x30)
	MOV  R14,R30
; 0000 0131         lcd_putchar (cyfh);
	ST   -Y,R12
	RCALL _lcd_putchar
; 0000 0132         lcd_putchar (cyfl);
	ST   -Y,R14
	RCALL _lcd_putchar
; 0000 0133         lcd_gotoxy(0,1);
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xE
; 0000 0134         polu=(volume&1);
	MOV  R30,R6
	ANDI R30,LOW(0x1)
	RCALL SUBOPT_0x1C
; 0000 0135         girno=(volume>>1);
	MOV  R30,R6
	LDI  R31,0
	SBRC R30,7
	SER  R31
	RCALL SUBOPT_0x1D
; 0000 0136         nichego=16-girno-polu;
	LDI  R26,LOW(16)
	LDI  R27,HIGH(16)
	RCALL SUBOPT_0x1E
; 0000 0137         for(j=0;j<girno;j++)lcd_putchar (4);
	CLR  R3
_0x4C:
	MOV  R30,R13
	RCALL SUBOPT_0x19
	BRGE _0x4D
	RCALL SUBOPT_0x9
	RCALL _lcd_putchar
	INC  R3
	RJMP _0x4C
_0x4D:
; 0000 0138 if(polu==1)lcd_putchar(5);
	LDS  R26,_polu
	CPI  R26,LOW(0x1)
	BRNE _0x4E
	RCALL SUBOPT_0xD
	RCALL _lcd_putchar
; 0000 0139         for(j=0;j<nichego;j++)lcd_putchar (3);
_0x4E:
	CLR  R3
_0x50:
	LDS  R30,_nichego
	RCALL SUBOPT_0x19
	BRGE _0x51
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x17
	INC  R3
	RJMP _0x50
_0x51:
; 0000 013A if (voltime<0)return;
	CLR  R0
	CP   R7,R0
	CPC  R8,R0
	BRGE _0x52
	RET
; 0000 013B         }
_0x52:
	RJMP _0x40
; 0000 013C }
;void main(void)
; 0000 013E { if (volstore>31){
_main:
	RCALL SUBOPT_0x28
	RCALL __EEPROMRDB
	CPI  R30,LOW(0x20)
	BRLO _0x53
; 0000 013F #asm("cli")
	cli
; 0000 0140 volstore=5;
	RCALL SUBOPT_0x28
	LDI  R30,LOW(5)
	RCALL __EEPROMWRB
; 0000 0141 delay_ms(100);
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x24
; 0000 0142 }
; 0000 0143 start: SMCR=0x04;
_0x53:
_0x54:
	LDI  R30,LOW(4)
	OUT  0x33,R30
; 0000 0144 // Declare your local variables here
; 0000 0145 vol2=0;
	CLR  R5
; 0000 0146 // Crystal Oscillator division factor: 1
; 0000 0147 #pragma optsize-
; 0000 0148 CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 0149 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 014A #ifdef _OPTIMIZE_SIZE_
; 0000 014B #pragma optsize+
; 0000 014C #endif
; 0000 014D 
; 0000 014E // Input/Output Ports initialization
; 0000 014F // Port B initialization
; 0000 0150 // Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0151 // State7=P State6=P State5=P State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 0152 PORTB=0xE0;
	LDI  R30,LOW(224)
	OUT  0x5,R30
; 0000 0153 DDRB=0x1F;
	LDI  R30,LOW(31)
	OUT  0x4,R30
; 0000 0154 
; 0000 0155 // Port C initialization
; 0000 0156 // Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 0157 // State6=P State5=1 State4=0 State3=P State2=P State1=T State0=T
; 0000 0158 PORTC=0x6C;
	LDI  R30,LOW(108)
	OUT  0x8,R30
; 0000 0159 DDRC=0x70;    //30
	LDI  R30,LOW(112)
	OUT  0x7,R30
; 0000 015A 
; 0000 015B // Port D initialization
; 0000 015C // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 015D // State7=T State6=T State5=T State4=T State3=P State2=T State1=T State0=T
; 0000 015E PORTD=0x08;
	LDI  R30,LOW(8)
	OUT  0xB,R30
; 0000 015F DDRD=0x00;
	LDI  R30,LOW(0)
	OUT  0xA,R30
; 0000 0160 
; 0000 0161 // Timer/Counter 0 initialization
; 0000 0162 // Clock source: System Clock
; 0000 0163 // Clock value: 125,000 kHz
; 0000 0164 // Mode: Normal top=0xFF
; 0000 0165 // OC0A output: Disconnected
; 0000 0166 // OC0B output: Disconnected
; 0000 0167 TCCR0A=0x00;
	OUT  0x24,R30
; 0000 0168 TCCR0B=0x03;
	LDI  R30,LOW(3)
	OUT  0x25,R30
; 0000 0169 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 016A OCR0A=0x00;
	OUT  0x27,R30
; 0000 016B OCR0B=0x00;
	OUT  0x28,R30
; 0000 016C 
; 0000 016D // Timer/Counter 1 initialization
; 0000 016E // Clock source: System Clock
; 0000 016F // Clock value: Timer1 Stopped
; 0000 0170 // Mode: Normal top=0xFFFF
; 0000 0171 // OC1A output: Discon.
; 0000 0172 // OC1B output: Discon.
; 0000 0173 // Noise Canceler: Off
; 0000 0174 // Input Capture on Falling Edge
; 0000 0175 // Timer1 Overflow Interrupt: Off
; 0000 0176 // Input Capture Interrupt: Off
; 0000 0177 // Compare A Match Interrupt: Off
; 0000 0178 // Compare B Match Interrupt: Off
; 0000 0179 TCCR1A=0x00;
	STS  128,R30
; 0000 017A TCCR1B=0x00;
	STS  129,R30
; 0000 017B TCNT1H=0x00;
	STS  133,R30
; 0000 017C TCNT1L=0x00;
	STS  132,R30
; 0000 017D ICR1H=0x00;
	STS  135,R30
; 0000 017E ICR1L=0x00;
	STS  134,R30
; 0000 017F OCR1AH=0x00;
	STS  137,R30
; 0000 0180 OCR1AL=0x00;
	STS  136,R30
; 0000 0181 OCR1BH=0x00;
	STS  139,R30
; 0000 0182 OCR1BL=0x00;
	STS  138,R30
; 0000 0183 
; 0000 0184 // Timer/Counter 2 initialization
; 0000 0185 // Clock source: System Clock
; 0000 0186 // Clock value: Timer2 Stopped
; 0000 0187 // Mode: Normal top=0xFF
; 0000 0188 // OC2A output: Disconnected
; 0000 0189 // OC2B output: Disconnected
; 0000 018A ASSR=0x00;
	STS  182,R30
; 0000 018B TCCR2A=0x00;
	STS  176,R30
; 0000 018C TCCR2B=0x00;
	STS  177,R30
; 0000 018D TCNT2=0x00;
	STS  178,R30
; 0000 018E OCR2A=0x00;
	STS  179,R30
; 0000 018F OCR2B=0x00;
	STS  180,R30
; 0000 0190 
; 0000 0191 // External Interrupt(s) initialization
; 0000 0192 // INT0: Off
; 0000 0193 // INT1: On
; 0000 0194 // INT1 Mode: Falling Edge
; 0000 0195 // Interrupt on any change on pins PCINT0-7: Off
; 0000 0196 // Interrupt on any change on pins PCINT8-14: Off
; 0000 0197 // Interrupt on any change on pins PCINT16-23: Off
; 0000 0198 EICRA=0x00;     // EICRA=0x08;
	STS  105,R30
; 0000 0199 EIMSK=0x02;
	LDI  R30,LOW(2)
	OUT  0x1D,R30
; 0000 019A EIFR=0x02;
	OUT  0x1C,R30
; 0000 019B PCICR=0x00;
	LDI  R30,LOW(0)
	STS  104,R30
; 0000 019C 
; 0000 019D // Timer/Counter 0 Interrupt(s) initialization
; 0000 019E TIMSK0=0x01;
	LDI  R30,LOW(1)
	STS  110,R30
; 0000 019F 
; 0000 01A0 // Timer/Counter 1 Interrupt(s) initialization
; 0000 01A1 TIMSK1=0x00;
	LDI  R30,LOW(0)
	STS  111,R30
; 0000 01A2 
; 0000 01A3 // Timer/Counter 2 Interrupt(s) initialization
; 0000 01A4 TIMSK2=0x00;
	STS  112,R30
; 0000 01A5 
; 0000 01A6 // USART initialization
; 0000 01A7 // USART disabled
; 0000 01A8 UCSR0B=0x00;
	STS  193,R30
; 0000 01A9 
; 0000 01AA // Analog Comparator initialization
; 0000 01AB // Analog Comparator: Off
; 0000 01AC // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 01AD ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
; 0000 01AE ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
; 0000 01AF DIDR1=0x00;
	STS  127,R30
; 0000 01B0 
; 0000 01B1 // ADC initialization
; 0000 01B2 // ADC Clock frequency: 250,000 kHz
; 0000 01B3 // ADC Voltage Reference: AVCC pin
; 0000 01B4 // ADC Auto Trigger Source: Free Running
; 0000 01B5 // Digital input buffers on ADC0: On, ADC1: On, ADC2: Off, ADC3: Off
; 0000 01B6 // ADC4: Off, ADC5: Off
; 0000 01B7 DIDR0=0x3C;
	LDI  R30,LOW(60)
	STS  126,R30
; 0000 01B8 ADMUX=FIRST_ADC_INPUT | (ADC_VREF_TYPE & 0xff);
	LDI  R30,LOW(64)
	STS  124,R30
; 0000 01B9 ADCSRA=0xEF;//ADCSRA=0xED;
	LDI  R30,LOW(239)
	RCALL SUBOPT_0x6
; 0000 01BA ADCSRB&=0xF8;
	LDS  R30,123
	ANDI R30,LOW(0xF8)
	STS  123,R30
; 0000 01BB 
; 0000 01BC // SPI initialization
; 0000 01BD // SPI disabled
; 0000 01BE SPCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x2C,R30
; 0000 01BF 
; 0000 01C0 // TWI initialization
; 0000 01C1 // TWI disabled
; 0000 01C2 TWCR=0x00;
	STS  188,R30
; 0000 01C3 
; 0000 01C4 // Alphanumeric LCD initialization
; 0000 01C5 // Connections specified in the
; 0000 01C6 // Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
; 0000 01C7 // RS - PORTD Bit 0
; 0000 01C8 // RD - PORTD Bit 1
; 0000 01C9 // EN - PORTD Bit 2
; 0000 01CA // D4 - PORTD Bit 4
; 0000 01CB // D5 - PORTD Bit 5
; 0000 01CC // D6 - PORTD Bit 6
; 0000 01CD // D7 - PORTD Bit 7
; 0000 01CE // Characters/line: 16
; 0000 01CF corr[0]=correctl;
	RCALL SUBOPT_0x20
; 0000 01D0 corr[1]=correctr;
; 0000 01D1 lcd_init(16);
	RCALL SUBOPT_0x8
; 0000 01D2 cyfh=0x40;
	LDI  R30,LOW(64)
	MOV  R12,R30
; 0000 01D3 for (j=0; j<64; j++) lcd_write_byte(cyfh++,znakog[j]);
	CLR  R3
_0x56:
	LDI  R30,LOW(64)
	CP   R3,R30
	BRGE _0x57
	MOV  R30,R12
	INC  R12
	ST   -Y,R30
	RCALL SUBOPT_0xB
	SUBI R30,LOW(-_znakog*2)
	SBCI R31,HIGH(-_znakog*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _lcd_write_byte
	INC  R3
	RJMP _0x56
_0x57:
; 0000 01D4 lcd_init(16);
	RCALL SUBOPT_0x8
; 0000 01D5 
; 0000 01D6 for (j=0;j<75;j++)
	CLR  R3
_0x59:
	LDI  R30,LOW(75)
	CP   R3,R30
	BRGE _0x5A
; 0000 01D7     {
; 0000 01D8     if(j==0) lcd_gotoxy(4,0);
	TST  R3
	BRNE _0x5B
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	RCALL _lcd_gotoxy
; 0000 01D9     if(j<16)lcd_putchar(bukvy[j]);
_0x5B:
	LDI  R30,LOW(16)
	CP   R3,R30
	BRGE _0x5C
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xC
; 0000 01DA 
; 0000 01DB     if(j==8) lcd_gotoxy(5,1);
_0x5C:
	LDI  R30,LOW(8)
	CP   R30,R3
	BRNE _0x5D
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
; 0000 01DC     if(j==60) PORTC|=16;
_0x5D:
	LDI  R30,LOW(60)
	CP   R30,R3
	BRNE _0x5E
	SBI  0x8,4
; 0000 01DD     if(j==70) PORTC&=223;
_0x5E:
	LDI  R30,LOW(70)
	CP   R30,R3
	BRNE _0x5F
	CBI  0x8,5
; 0000 01DE     delay_ms(100);
_0x5F:
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x24
; 0000 01DF     }
	INC  R3
	RJMP _0x59
_0x5A:
; 0000 01E0 on=1;
	SBI  0x1E,2
; 0000 01E1 for(del=0; del<18000;del++)
	CLR  R9
	CLR  R10
_0x63:
	LDI  R30,LOW(18000)
	LDI  R31,HIGH(18000)
	CP   R9,R30
	CPC  R10,R31
	BRGE _0x64
; 0000 01E2     {if (PINB.6!=krut)
	RCALL SUBOPT_0x10
	BREQ _0x65
; 0000 01E3         {voltime=1000;
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
; 0000 01E4         }
; 0000 01E5 
; 0000 01E6     }
_0x65:
	RCALL SUBOPT_0x13
	__ADDWRR 9,10,30,31
	RJMP _0x63
_0x64:
; 0000 01E7 encoder_pos=volstore;
	RCALL SUBOPT_0x28
	RCALL __EEPROMRDB
	RCALL SUBOPT_0x2
; 0000 01E8 krut=PINB.6;
	SBIC 0x3,6
	RJMP _0x66
	CBI  0x1E,0
	RJMP _0x67
_0x66:
	SBI  0x1E,0
_0x67:
; 0000 01E9 encoder_state=0xF0;
	LDI  R30,LOW(240)
	MOV  R4,R30
; 0000 01EA voltime=1000;
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
; 0000 01EB falltime[0]=255;
	LDI  R30,LOW(255)
	STS  _falltime,R30
; 0000 01EC falltime[1]=255;
	__PUTB1MN _falltime,1
; 0000 01ED zamer[1]=0;
	LDI  R30,LOW(0)
	__PUTB1MN _zamer,1
; 0000 01EE zamer[0]=0;
	STS  _zamer,R30
; 0000 01EF // Global enable interrupts
; 0000 01F0 #asm("sei")
	sei
; 0000 01F1 
; 0000 01F2 while (1)
_0x68:
; 0000 01F3       {
; 0000 01F4 
; 0000 01F5       // Place your code here
; 0000 01F6     if ((on)&&(!PIND.3)&&(dela<100)) {
	SBIS 0x1E,2
	RJMP _0x6C
	SBIC 0x9,3
	RJMP _0x6C
	LDS  R26,_dela
	CPI  R26,LOW(0x64)
	BRLO _0x6D
_0x6C:
	RJMP _0x6B
_0x6D:
; 0000 01F7 
; 0000 01F8         dela++;
	LDS  R30,_dela
	SUBI R30,-LOW(1)
	STS  _dela,R30
; 0000 01F9         delay_ms(10);
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x24
; 0000 01FA         }
; 0000 01FB         else if (dela<50) dela=0;
	RJMP _0x6E
_0x6B:
	LDS  R26,_dela
	CPI  R26,LOW(0x32)
	BRSH _0x6F
	LDI  R30,LOW(0)
	STS  _dela,R30
; 0000 01FC 
; 0000 01FD 
; 0000 01FE     if (dela>=50){
_0x6F:
_0x6E:
	LDS  R26,_dela
	CPI  R26,LOW(0x32)
	BRLO _0x70
; 0000 01FF         #asm("cli")
	cli
; 0000 0200         volstore=volume;
	MOV  R30,R6
	RCALL SUBOPT_0x28
	RCALL __EEPROMWRB
; 0000 0201         delay_ms(100);
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x24
; 0000 0202         lcd_init(16);
	RCALL SUBOPT_0x8
; 0000 0203         lcd_putchar (73);
	LDI  R30,LOW(73)
	RCALL SUBOPT_0x17
; 0000 0204         lcd_putchar (39);
	LDI  R30,LOW(39)
	RCALL SUBOPT_0x17
; 0000 0205         lcd_putchar (108);
	LDI  R30,LOW(108)
	RCALL SUBOPT_0x17
; 0000 0206         lcd_putchar (108);
	LDI  R30,LOW(108)
	RCALL SUBOPT_0x17
; 0000 0207         lcd_putchar (32);
	RCALL SUBOPT_0xF
; 0000 0208         lcd_putchar (98);
	LDI  R30,LOW(98)
	RCALL SUBOPT_0x17
; 0000 0209         lcd_putchar (101);
	LDI  R30,LOW(101)
	RCALL SUBOPT_0x17
; 0000 020A         lcd_putchar (32);
	RCALL SUBOPT_0xF
; 0000 020B         lcd_putchar (98);
	LDI  R30,LOW(98)
	RCALL SUBOPT_0x17
; 0000 020C         lcd_putchar (97);
	LDI  R30,LOW(97)
	RCALL SUBOPT_0x17
; 0000 020D         lcd_putchar (99);
	LDI  R30,LOW(99)
	RCALL SUBOPT_0x17
; 0000 020E         lcd_putchar (107);
	LDI  R30,LOW(107)
	RCALL SUBOPT_0x17
; 0000 020F         lcd_putchar (46);
	LDI  R30,LOW(46)
	RCALL SUBOPT_0x17
; 0000 0210         lcd_putchar (46);
	LDI  R30,LOW(46)
	RCALL SUBOPT_0x17
; 0000 0211         lcd_putchar (46);
	LDI  R30,LOW(46)
	RCALL SUBOPT_0x17
; 0000 0212         lcd_putchar (32);
	RCALL SUBOPT_0xF
; 0000 0213         lcd_gotoxy(0,1);
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xE
; 0000 0214         //for (nichego=0;nichego<16;nichego++) lcd_putchar (32);
; 0000 0215         delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RCALL SUBOPT_0x24
; 0000 0216         PORTC=0;
	LDI  R30,LOW(0)
	OUT  0x8,R30
; 0000 0217         PORTB=0;
	OUT  0x5,R30
; 0000 0218         dela=0;
	STS  _dela,R30
; 0000 0219         on=0;
	CBI  0x1E,2
; 0000 021A         #asm("sei")
	sei
; 0000 021B         lcd_init(16);
	RCALL SUBOPT_0x8
; 0000 021C         SMCR=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 021D         #asm("sleep")
	sleep
; 0000 021E         goto start;
	RJMP _0x54
; 0000 021F         }
; 0000 0220     else {
_0x70:
; 0000 0221         if (vol2!=volume){
	CP   R6,R5
	BREQ _0x74
; 0000 0222         PORTB&=(0xE0|volume);
	RCALL SUBOPT_0x25
; 0000 0223         delay_ms(7);
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RCALL SUBOPT_0x24
; 0000 0224         PORTB|=volume;
	RCALL SUBOPT_0x26
; 0000 0225         vol2=volume;}
; 0000 0226         ADCSRA=0xCB;                      // ADCSRA=0xCD;
_0x74:
	LDI  R30,LOW(203)
	RCALL SUBOPT_0x6
; 0000 0227         TIMSK0=0x00;
	LDI  R30,LOW(0)
	STS  110,R30
; 0000 0228         if (PINB.6!=krut)
	RCALL SUBOPT_0x10
	BREQ _0x75
; 0000 0229         {voltime=1000;
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
; 0000 022A         krut=PINB.6;}
	SBIC 0x3,6
	RJMP _0x76
	CBI  0x1E,0
	RJMP _0x77
_0x76:
	SBI  0x1E,0
_0x77:
; 0000 022B 
; 0000 022C         if (voltime>1) volu();
_0x75:
	RCALL SUBOPT_0x13
	CP   R30,R7
	CPC  R31,R8
	BRGE _0x78
	RCALL _volu
; 0000 022D 
; 0000 022E         else
	RJMP _0x79
_0x78:
; 0000 022F             {        //  if ((volcor[0]<=3)&&(volcor[1]<=3)) ssav();
; 0000 0230    //         if ((adc_data[0]<=corr[0])&&(adc_data[1]<=corr[1])) ssav();
; 0000 0231             if (((adc_data[0]-corr[0])<3)&&((adc_data[1]-corr[1])<3)) ssav();
	RCALL SUBOPT_0x11
	SBIW R30,3
	BRGE _0x7B
	RCALL SUBOPT_0x12
	SBIW R26,3
	BRLT _0x7C
_0x7B:
	RJMP _0x7A
_0x7C:
	RCALL _ssav
; 0000 0232           else adclog();
	RJMP _0x7D
_0x7A:
	RCALL _adclog
; 0000 0233 
; 0000 0234 //         if ((volcor[0]>3)||(volcor[1]>3)) adclog();
; 0000 0235             }
_0x7D:
_0x79:
; 0000 0236         }
; 0000 0237       }
	RJMP _0x68
; 0000 0238 }
_0x7E:
	RJMP _0x7E
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G100:
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2000004
	SBI  0xB,4
	RJMP _0x2000005
_0x2000004:
	CBI  0xB,4
_0x2000005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2000006
	SBI  0xB,5
	RJMP _0x2000007
_0x2000006:
	CBI  0xB,5
_0x2000007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2000008
	SBI  0xB,6
	RJMP _0x2000009
_0x2000008:
	CBI  0xB,6
_0x2000009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x200000A
	SBI  0xB,7
	RJMP _0x200000B
_0x200000A:
	CBI  0xB,7
_0x200000B:
	__DELAY_USB 5
	SBI  0xB,2
	__DELAY_USB 13
	CBI  0xB,2
	__DELAY_USB 13
	RJMP _0x2020001
__lcd_write_data:
	LD   R30,Y
	RCALL SUBOPT_0x29
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R30,Y
	RCALL SUBOPT_0x29
	__DELAY_USB 133
	RJMP _0x2020001
_lcd_write_byte:
	LDD  R30,Y+1
	RCALL SUBOPT_0x2A
	SBI  0xB,0
	LD   R30,Y
	RCALL SUBOPT_0x2A
	CBI  0xB,0
	RJMP _0x2020002
_lcd_gotoxy:
	LD   R30,Y
	RCALL SUBOPT_0x0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x2A
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
_0x2020002:
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x2A
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0x24
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x2A
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x2A
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0x24
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2000011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2000010
_0x2000011:
	RCALL SUBOPT_0xA
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2020001
_0x2000010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	SBI  0xB,0
	LD   R30,Y
	RCALL SUBOPT_0x2A
	CBI  0xB,0
	RJMP _0x2020001
_lcd_init:
	SBI  0xA,4
	SBI  0xA,5
	SBI  0xA,6
	SBI  0xA,7
	SBI  0xA,2
	SBI  0xA,0
	SBI  0xA,1
	CBI  0xB,2
	CBI  0xB,0
	CBI  0xB,1
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0x24
	LDI  R30,LOW(48)
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2C
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x2C
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x9
	RCALL __lcd_write_data
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x2A
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x2A
	RCALL _lcd_clear
_0x2020001:
	ADIW R28,1
	RET

	.ESEG
_volstore:
	.BYTE 0x1
_correctl:
	.BYTE 0x2
_correctr:
	.BYTE 0x2

	.DSEG
_zamer:
	.BYTE 0x2
_falltime:
	.BYTE 0x2
_encoder_pos:
	.BYTE 0x1
_volcor:
	.BYTE 0x4
_polu:
	.BYTE 0x1
_nichego:
	.BYTE 0x1
_dela:
	.BYTE 0x1
_corr:
	.BYTE 0x4
_adc_data:
	.BYTE 0x4
_input_index_S0000002000:
	.BYTE 0x1
__base_y_G100:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 36 TIMES, CODE SIZE REDUCTION:68 WORDS
SUBOPT_0x0:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	LDS  R26,_encoder_pos
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	STS  _encoder_pos,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	__PUTW1R 7,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5:
	RCALL SUBOPT_0x0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6:
	STS  122,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(205)
	RCALL SUBOPT_0x6
	LDI  R30,LOW(0)
	STS  110,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(16)
	ST   -Y,R30
	RJMP _lcd_init

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(4)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	MOV  R30,R3
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	SUBI R30,LOW(-_bukvy*2)
	SBCI R31,HIGH(-_bukvy*2)
	LPM  R30,Z
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(5)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(32)
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x10:
	LDI  R26,0
	SBIC 0x3,6
	LDI  R26,1
	LDI  R30,0
	SBIC 0x1E,0
	LDI  R30,1
	LDI  R27,0
	SBRC R26,7
	SER  R27
	RCALL SUBOPT_0x0
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x11:
	LDS  R26,_corr
	LDS  R27,_corr+1
	LDS  R30,_adc_data
	LDS  R31,_adc_data+1
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x12:
	__GETW2MN _adc_data,2
	__GETW1MN _corr,2
	SUB  R26,R30
	SBC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	__GETW1MN _adc_data,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x15:
	LDI  R30,0
	SBIC 0x1E,1
	LDI  R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x16:
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 26 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x17:
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x18:
	RCALL SUBOPT_0x0
	SUBI R30,LOW(-_zamer)
	SBCI R31,HIGH(-_zamer)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x19:
	MOV  R26,R3
	LDI  R27,0
	SBRC R26,7
	SER  R27
	RCALL SUBOPT_0x0
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1A:
	RCALL SUBOPT_0x0
	SUBI R30,LOW(-_falltime)
	SBCI R31,HIGH(-_falltime)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1B:
	MOVW R26,R30
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	STS  _polu,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1D:
	ASR  R31
	ROR  R30
	MOV  R13,R30
	MOV  R30,R13
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1E:
	SUB  R26,R30
	SBC  R27,R31
	LDS  R30,_polu
	RCALL SUBOPT_0x0
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	STS  _nichego,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1F:
	RCALL __EEPROMWRW
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x20:
	LDI  R26,LOW(_correctl)
	LDI  R27,HIGH(_correctl)
	RCALL __EEPROMRDW
	STS  _corr,R30
	STS  _corr+1,R31
	LDI  R26,LOW(_correctr)
	LDI  R27,HIGH(_correctr)
	RCALL __EEPROMRDW
	__PUTW1MN _corr,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x21:
	LDS  R30,_polu
	LDI  R26,LOW(_corr)
	LDI  R27,HIGH(_corr)
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x23:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x24:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x25:
	IN   R30,0x5
	MOV  R26,R30
	MOV  R30,R6
	ORI  R30,LOW(0xE0)
	AND  R30,R26
	OUT  0x5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	IN   R30,0x5
	OR   R30,R6
	OUT  0x5,R30
	MOV  R5,R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x27:
	MOV  R26,R6
	LDI  R27,0
	SBRC R26,7
	SER  R27
	RJMP SUBOPT_0x23

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	LDI  R26,LOW(_volstore)
	LDI  R27,HIGH(_volstore)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x29:
	ST   -Y,R30
	RJMP __lcd_write_nibble_G100

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2A:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2B:
	__DELAY_USW 200
	LDI  R30,LOW(48)
	RJMP SUBOPT_0x29

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2C:
	__DELAY_USW 200
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
